/*
	$Id: SCCommunicateBoxController.java,v 1.2 2002/12/08 16:10:04 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCCommunicateBoxController extends NSWindowController
{
    SCSession session;
    
    // IB Outlets
    NSTextField textfield;
    
    public SCCommunicateBoxController(SCSession session)
    {
		super("CommunicateBox");
		this.session = session;
		
		window();
		window().setTitle("COMMUNICATE : "+session.getSelfName());
    }
    
    public void showWindow(Object sender)
    {
		// \ׂʒuvZB
		// {̃VF̍COM{bNX̍킹邪A؂̖ʒu܂ł炵ďCB
		final int screenWidth = (int)NSScreen.mainScreen().frame().width();
		final int shellLeft = (int)session.getHontai().x();
		final int shellTop = (int)session.getHontai().height();
		int comboxLeft = shellLeft;
		int comboxBottom = shellTop;
		if (comboxLeft < 0)
		{
			comboxLeft = 0;
		}
		else if (comboxLeft + window().frame().width() > screenWidth)
		{
			comboxLeft = screenWidth - (int)window().frame().width();
		}
		window().setFrameOrigin(new NSPoint(comboxLeft,comboxBottom));
		
		super.showWindow(sender);
    }
    
    public void show()
    {
		if (window().isVisible()) return;
		
			//windowCtrl.showWindow(null);
		NSTimer open_timer = new NSTimer(
					0.0,
					this,
					new NSSelector("showWindow",new Class[] {NSNull.class}),
					new Object[] {NSNull.nullValue()},
					false);
		SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(open_timer,NSRunLoop.DefaultRunLoopMode);
		if (!Thread.currentThread().getName().equals("main")) while (!window().isVisible()) {} // ҋ@
    }
    
    public void close(Object sender)
    {
		window().orderOut(sender);
    }
    
    // IB Actions
    public void send(Object sender)
    {
		if (textfield.stringValue().length() == 0) return;
		
		session.doShioriCommunicateFromUser(textfield.stringValue());
		textfield.setStringValue("");
    }
}
