/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;

public class SCESStringCommands extends SCESCommands
{
    public SCESStringCommands(SCEseShiori e)
    {
	super(e);
    }
    
    public String GETSENTRES(Vector args) throws Exception
    {
	/*
	    @F$GETSENTRES( str1 , str2 [,n,flag] )
	    ߂lFflag == 1Ȃ猋ʂԂ
	    
	    ŌSHIORIɓ͂ꂽCxgR~jP[g̕񂩂
	    str1str2ŋ܂ꂽ͈͂oāA
	    nw肳ĂΔėpL̈nԂɂA
	    flag == 1Ȃ猋ʂԂB
	*/
	String str1 = eseshiori.getEvaluator().validateStringArgument((String)args.elementAt(0));
	String str2 = eseshiori.getEvaluator().validateStringArgument((String)args.elementAt(1));
	
	String world = eseshiori.getLatestInputString();
	int str1_pos = world.indexOf(str1);
	if (str1_pos == -1) return null; // str1݂Ȃ
	int str2_pos = world.indexOf(str2,str1_pos+str1.length());
	if (str2_pos == -1) return null; // str2݂Ȃ
	String result = world.substring(str1_pos+str1.length(),str2_pos);
	
	if (args.size() >= 3)
	{
	    String n = (String)args.elementAt(2);
	    if (n.length() > 0) // ȗĂ󔒂ɂȂĂ
	    {
		eseshiori.putToUnivDataArea(Integer.parseInt(n),result);
	    }
	}
	if (args.size() >= 4)
	{
	    String flag = (String)args.elementAt(3);
	    return (flag.equals("1") ? result : null);
	}
	else
	{
	    return null;
	}
    }
    
    public String GETPOP(Vector args) throws Exception
    {
	/*
	    @F$GETPOP( pop_no , str1 , str2 [,push_no,flag] )
	    ߂lFflag == 1Ȃ猋ʂԂ
	    
	    ėpL̈pop_noԖڂstr1str2ŋ܂ꂽ͈͂oāA
	    push_now肳ĂΔėpL̈nԂɂA
	    flag == 1Ȃ猋ʂԂB
	*/
	String pop_no = (String)args.elementAt(0);
	String str1 = eseshiori.getEvaluator().validateStringArgument((String)args.elementAt(1));
	String str2 = eseshiori.getEvaluator().validateStringArgument((String)args.elementAt(2));
	
	String world = eseshiori.getFromUnivDataArea(Integer.parseInt(pop_no));
	int str1_pos = world.indexOf(str1);
	if (str1_pos == -1) return null; // str1݂Ȃ
	int str2_pos = world.indexOf(str2,str1_pos+str1.length());
	if (str2_pos == -1) return null; // str2݂Ȃ
	String result = world.substring(str1_pos+str1.length(),str2_pos);
	
	if (args.size() >= 4)
	{
	    String push_no = (String)args.elementAt(3);
	    if (push_no.length() > 0) // ȗĂ󔒂ɂȂĂ
	    {
		eseshiori.putToUnivDataArea(Integer.parseInt(push_no),result);
	    }
	}
	if (args.size() >= 5)
	{
	    String flag = (String)args.elementAt(4);
	    return (flag.equals("1") ? result : null);
	}
	else
	{
	    return null;
	}
    }
}
