/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;

public class SCNSDtx
{
    int x;
    int[] buf;
    
    public SCNSDtx()
    {
	buf = new int[10000];
    }
    
    public ByteArrayInputStream decodeDtx(File file)
    {
        FileInputStream fis = null;
        try
        {
            fis = new FileInputStream(file);
        }catch(Exception e){return null;}
        
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        
        x = 0x61;
        while (decode(fis,out) == 0) { out.write('\n'); }
        
        return new ByteArrayInputStream(out.toByteArray());
    }
    
    int decode(FileInputStream fis,ByteArrayOutputStream out)
    {
        int c,ix = 0;
        
        try
        {
            while((c = fis.read()) != -1)
            {
                if (c == 0x40)
                {
                    buf[ix] = 0;
                    break;
                }
                buf[ix] = c;
                ix++;
                if (ix == 9999)
                {
                    buf[ix] = 0;
                    break;
                }
            }
            if (c == -1) return 1; // I
        }
        catch (Exception e){ return 1; }
        
        int strlen_buf = ix;
        int w1,w2,w3,w4;
        int[] b = new int[2];
        for (int i = 0;i < strlen_buf;i += 2)
        {
           b[1] = buf[i+1] - x; x+=9;
           b[0] = buf[i] - x; x+=2;
           if (x >= 0xdd)
            {
           	x = 0x61;
            }
            
            w4 = b[1] & 0x03;
            w3 = (b[0] & 0x03) << 2;
            w2 = (b[0] & 0x0C) << 2;
            w1 = (b[1] & 0x0C) << 4;
            
            c = w4 | w3 | w2 | w1;
            
            out.write(c);
        }
        
        return 0; // ܂cĂ
    }
}
