/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#import "SCNoiseImageGenerator_Impl.h"

@implementation SCNoiseImageGenerator_Impl

- (id)_initWithJavaObject:(id)sender
{
    srand(time(NULL));
    return self;
}

- (void)scramble:(NSImage *)image
{
    // image : At@`lt32bitRGB̂݁B
    NSBitmapImageRep *bitmapRep;
    int bytesPerPlane,i;
    unsigned char *data;
    
    bitmapRep = [[image representations] objectAtIndex:0];
    data = [bitmapRep bitmapData];
    bytesPerPlane = [bitmapRep bytesPerPlane];
    for (i = 0;i < bytesPerPlane;i += 4)
    {
	unsigned char gray,alpha;
	
	gray = (unsigned char)(rand() % 255);
	alpha = (unsigned char)(rand() % 200);
	
	data[i] = data[i+1] = data[i+2] = gray;
	data[i+3] = alpha;
    }
}

@end
