/*
	$Id: SCSelectorInvoker.java,v 1.2 2002/12/08 16:10:06 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;


public class SCSelectorInvoker extends Thread
{
    NSSelector selector;
    Object target;
    Object[] arguments;
    
    public SCSelectorInvoker(NSSelector selector,Object target,Object[] arguments)
    {
		this.selector = selector;
		this.target = target;
		this.arguments = arguments;
    }
    
    public void run()
    {
		int pool = NSAutoreleasePool.push();
		
		try{ selector.invoke(target,arguments); }catch(Exception e){}
		
		NSAutoreleasePool.pop(pool);
    }
}
