/*  $Id: ConditionTokenizer.java,v 1.2 2004/01/29 12:14:45 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package satori;
import satori.*;

public class ConditionTokenizer {
    StringBuffer buf;
    
    public ConditionTokenizer(String cond) {
	// ɒ̂nĉB
	buf = new StringBuffer(cond);
    }
    
    public boolean hasMoreTokens() {
	return (buf.length() > 0);
    }
    
    protected String startsWithOperator(String world,int pos) {
	// worldposԖڂ̕牉Zqn܂Ă炻̉ZqA
	// łȂnullԂB
	String result = null;
	if (world.charAt(pos) == '*') {
	    result = "*";
	}
	else if (world.startsWith("<=",pos)) {
	    result = "<=";
	}
	else if (world.charAt(pos) == '<') {
	    result = "<";
	}
	else if (world.startsWith(">=",pos)) {
	    result = ">=";
	}
	else if (world.charAt(pos) == '>') {
	    result = ">";
	}
	else if (world.charAt(pos) == '(') {
	    result = "(";
	}
	else if (world.charAt(pos) == ')') {
	    result = ")";
	}
	else if (world.charAt(pos) == '%') {
	    result = "%";
	}
	else if (world.charAt(pos) == '-') {
	    result = "-";
	}
	else if (world.startsWith("!=",pos)) {
	    result = "!=";
	}
	else if (world.charAt(pos) == '!') {
	    result = "!";
	}
	else if (world.charAt(pos) == '^') {
	    result = "^";
	}
	else if (world.charAt(pos) == '/') {
	    result = "/";
	}
	else if (world.charAt(pos) == '^') {
	    result = "^";
	}
	else if (world.startsWith("==",pos)) {
	    result = "==";
	}
	else if (world.charAt(pos) == '+') {
	    result = "+";
	}
	else if (world.startsWith("&&",pos)) {
	    result = "&&";
	}
	else if (world.startsWith("||",pos)) {
	    result = "||";
	}
	return result;
    }
    
    public String nextToken() throws Exception {
	String result = null;
	
	result = startsWithOperator(buf.toString(),0);
	if (result == null) {
	    // ̉ZqTB΍Ō܂ł̃g[NłB
	    final int len = buf.length();
	    for (int i = 1;i < len;i++) {
		if (startsWithOperator(buf.toString(),i) != null) {
		    // ZqnP[BZqO̕ԂB
		    result = buf.substring(0,i);
		    break;
		}
	    }
	    if (result == null) {
		result = buf.toString();
	    }
	}
	
	buf.delete(0,result.length());
	return result;
    }
}
