/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;

public class SCFileClassLoader extends ClassLoader
{
    public Class loadClassFile(File f)
    {
	// 炩̗RŃNX쐬oȂnullԂ܂B
	try
	{
	    FileInputStream fis = new FileInputStream(f);
	    ByteArrayOutputStream baos = new ByteArrayOutputStream();
	    
	    byte[] buffer = new byte[512];
	    while (true)
	    {
		int count = fis.read(buffer);
		if (count == -1) break; // eof
		
		baos.write(buffer,0,count);
	    }
	    
	    byte[] classData = baos.toByteArray();
	    return defineClass(null,classData,0,classData.length);
	}
	catch (Exception e)
	{
	    System.err.println("SCFileClassLoader : couldn\'t load class file "+f.getPath());
	    e.printStackTrace();
	    
	    return null;
	}
    }
}
