/*
	$Id: SCInstallDialogController.java,v 1.2 2002/12/08 16:10:04 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCInstallDialogController extends NSWindowController
{
    private NSTextField messagefield;
    private NSTextField headfield;
    private NSButton closebutton;
    
    public SCInstallDialogController()
    {
		super("InstallDialog");
		window();
		
		headfield.setStringValue(SCStringsServer.getStrFromMainDic("installdialog.doing"));
		messagefield.setStringValue("");
		//window().setLevel(NSWindow.StatusWindowLevel);
    }
    
    public void show()
    {
		if (window().isVisible()) return;
		
		NSTimer open_timer = new NSTimer(
					0.0,
					this,
					new NSSelector("showWindow",new Class[] {NSNull.class}),
					new Object[] {NSNull.nullValue()},
					false);
		SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(open_timer,NSRunLoop.DefaultRunLoopMode);
		if (!Thread.currentThread().getName().equals("main")) while (!window().isVisible()) {} // ҋ@
    }
    
    public void writeLine(String line)
    {
		messagefield.setStringValue( messagefield.stringValue() + line + "\n" );
    }
    
    public void failed()
    {
		headfield.setStringValue(SCStringsServer.getStrFromMainDic("installdialog.failed"));
		closebutton.setEnabled(true);
    }
    
    public void succeeded()
    {
		headfield.setStringValue(SCStringsServer.getStrFromMainDic("installdialog.succeeded"));
		closebutton.setEnabled(true);
    }
}
