/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;
import util.*;

public class SCScriptServer
{
    Vector entries; // gSCScriptEntryNXB
    
    public SCScriptServer()
    {
        entries = new Vector();
    }
    
    public String findEntry(String name)
    {
        // GgT܂BȂnullԂ܂B
        int n_entries = entries.size();
        for (int i = 0;i < n_entries;i++)
        {
            SCScriptEntry ent = (SCScriptEntry)entries.elementAt(i);
            if (ent.getName().equals(name)) return ent.getScript();
        }
        
        return null;
    }
    
    public void addEntry(SCScriptEntry ent)
    {
	entries.add(ent);
    }
    
    public void dump()
    {
        // SCScriptServer̃fobOpBsɂ͕KvȂB
        int n_entries = entries.size();
        for (int i = 0;i < n_entries;i++)
        {
            SCScriptEntry ent = (SCScriptEntry)entries.elementAt(i);
            System.out.println("#"+ent.getName()+"\n   "+ent.getScript()+"\n");
        }
    }
    
    public void sweepAway()
    {
	entries.clear();
    }

    protected void finalize() {
	Logger.log(this, Logger.DEBUG, "finalized");
    }
}
